/// <reference types="node" />
declare module '@ioc:Adonis/Core/HttpContext' {
    import { RouteNode } from '@ioc:Adonis/Core/Route';
    import { IncomingMessage, ServerResponse } from 'http';
    import { LoggerContract } from '@ioc:Adonis/Core/Logger';
    import { RequestContract } from '@ioc:Adonis/Core/Request';
    import { ResponseContract } from '@ioc:Adonis/Core/Response';
    import { ServerConfigContract } from '@ioc:Adonis/Core/Server';
    import { ProfilerRowContract } from '@ioc:Adonis/Core/Profiler';
    export interface HttpContextContract {
        request: RequestContract;
        response: ResponseContract;
        logger: LoggerContract;
        profiler: ProfilerRowContract;
        route?: RouteNode;
        params: any;
        subdomains: any;
    }
    export interface HttpContextConstructorContract {
        create(routePattern: string, routeParams: any, logger: LoggerContract, profiler: ProfilerRowContract, req?: IncomingMessage, res?: ServerResponse, serverConfig?: ServerConfigContract): HttpContextContract;
        new (request: RequestContract, response: ResponseContract, logger: LoggerContract, profiler: ProfilerRowContract): HttpContextContract;
    }
    const HttpContext: HttpContextConstructorContract;
    export default HttpContext;
}
