/// <reference path="../../adonis-typings/index.d.ts" />
/// <reference path="../../adonis-typings/route.d.ts" />
import { EncryptionContract } from '@ioc:Adonis/Core/Encryption';
import { RouteNode, RouterContract, MatchedRoute, RouteLookupNode, RouteHandlerNode, MakeUrlOptions } from '@ioc:Adonis/Core/Route';
import { Route } from './Route';
import { RouteGroup } from './Group';
import { BriskRoute } from './BriskRoute';
import { RouteResource } from './Resource';
export declare class Router implements RouterContract {
    private _encryption;
    private _routeProcessor?;
    routes: (Route | RouteResource | RouteGroup | BriskRoute)[];
    BriskRoute: typeof BriskRoute;
    RouteGroup: typeof RouteGroup;
    RouteResource: typeof RouteResource;
    Route: typeof Route;
    private _matchers;
    private _store;
    private _lookupStore;
    private _openedGroups;
    private _testRoutePatternCounter;
    private _getRecentGroup;
    private _testsHandler;
    constructor(_encryption: EncryptionContract, _routeProcessor?: ((route: RouteNode) => void) | undefined);
    route(pattern: string, methods: string[], handler: RouteHandlerNode): Route;
    any(pattern: string, handler: RouteHandlerNode): Route;
    get(pattern: string, handler: RouteHandlerNode): Route;
    post(pattern: string, handler: RouteHandlerNode): Route;
    put(pattern: string, handler: RouteHandlerNode): Route;
    patch(pattern: string, handler: RouteHandlerNode): Route;
    destroy(pattern: string, handler: RouteHandlerNode): Route;
    group(callback: () => void): RouteGroup;
    resource(resource: string, controller: string): RouteResource;
    shallowResource(resource: string, controller: string): RouteResource;
    on(pattern: string): BriskRoute;
    where(param: string, matcher: string | RegExp): this;
    toJSON(): import("@ioc:Adonis/Core/Route").RouteDefinition[];
    commit(): void;
    match(url: string, method: string, domain?: string): null | MatchedRoute;
    lookup(routeIdentifier: string, forDomain?: string): null | RouteLookupNode;
    makeUrl(routeIdentifier: string, options?: MakeUrlOptions, domain?: string): string | null;
    makeSignedUrl(routeIdentifier: string, options?: MakeUrlOptions & {
        expiresIn?: string | number;
    }, domain?: string): string | null;
    forTesting(pattern?: string, methods?: string[], handler?: RouteHandlerNode): Route;
}
